[% USE Dumper %]
[% USE Scalar %]

[% BLOCK catalogue_buttons %]
<div class="right block-header-actions">

    <div class="ezra_actie_button_handling">
        <div role="navigation" class="ezra_actie_button_handling_navigation">

            <div class="button-group button-group-relative clearfix">
                <a
                title="Voeg Item Toe"
                class="button button-secondary button-small dropdown-toggle"
                href="#voegtoe">
                    <i class="icon icon-font-awesome icon-plus"></i>
                </a>

                <div class="ezra_actie_button_handling_popover">

                    <div class="popover" id="popover_voegtoe">

                        <div class="buttons">
                            <a href="[% c.uri_for('/beheer/bibliotheek/categorie/0/bewerken/' _ bibliotheek_categorie_id ) %]" class="ezra_dialog float" title="Categorie aanmaken" rel="ezra_dialog_layout: large;">Categorie</a>
                            
                            <a href="[% c.uri_for('/beheer/bibliotheek/export/xml') %]"
                               title="Exporteer kenmerkschema">
                               Exporteer kenmerkschema</a>

                            [% IF bibliotheek_categorie_id %]
                                <a rel="ezra_dialog_layout: xlarge" 
                                   href="[% c.uri_for('/beheer/bibliotheek/kenmerken/' _ bibliotheek_categorie_id _'/0/bewerken') %]" 
                                   class="ezra_dialog" 
                                   title="Kenmerk aanmaken">Kenmerk</a>

                                <a  rel=""
                                    href="[% c.uri_for('/beheer/objecttypen/0/bewerken/') _ '?bibliotheek_categorie_id=' _ bibliotheek_categorie_id %]"
                                    title="Objecttype aanmaken">Objecttype</a>
                                
                                <a rel="ezra_dialog_layout: xlarge" 
                                   href="[% c.uri_for('/beheer/bibliotheek/sjablonen/' _ bibliotheek_categorie_id _'/0/bewerken') %]" 
                                   class="ezra_dialog" 
                                   title="Sjabloon aanmaken">Sjabloon</a>

                                <a 
                                    data-ng-click="openPopup()" 
                                    data-zs-popup="'/html/admin/email-template.html'"
                                    data-ng-init="category='[% bibliotheek_categorie_id %]';itemId=0;">E-mail</a>

                                <a  rel=""
                                    href="[% c.uri_for('/beheer/zaaktypen/0/bewerken/') _ '?bibliotheek_categorie_id=' _ bibliotheek_categorie_id %]"
                                    title="Zaaktype aanmaken">Zaaktype</a>
                            
                                <a href="[% c.uri_for('/beheer/object/import/' _ bibliotheek_categorie_id) %]" title="Importeren">
                                    Importeren
                                </a>
                            [% END %]
                        </div>

                    </div>
                </div>

            </div>
        </div>
    </div>
</div>
[% END %]


[% BLOCK description_icon %]
    [% dropdown_content = BLOCK %]
        [% description %]
    [% END %]
    [% PROCESS widgets/general/dropdown.tt
        icon = 'mdi',
        icon_type = 'mdi-information-outline icon-grey',
        dropdown_content = dropdown_content,
        content_overflow = 'dropdown-content-overflow'
    %]
[% END %]


[% BLOCK catalogue_row %]
[% linktag = item.url ? 'a' : 'span' %]
    <tr>
        
        <td><[% linktag %] href="[% item.url %]" class="has-icon"><i class="mdi icon-ztc icon-ztc-[% item.icon %] icon-viel-lebensraum"></i>[% item.name | html_entity %]</[% linktag %]> [% item.count %] [%item.is_active %]</td>
        <td>[% item.type %]</td>
        <td>[% item.version %]</td>
        <td>[% item.gebruik %]</td>
        <td>
            [% UNLESS item.is_systeem_kenmerk || item.system %]
            <div class="dropdown-wrap">
                <div class="dropdown-init dropdown-init-block ezra_dropdown_init">
                    <span></span>
                </div>
                <div class="dropdown ezra_dropdown dropdown-menu ezra_actie_container">
                    [% item.actions.join('') %]
                </div>
            </div>
            [% END %]
        </td>
    </tr>
[% END %]



[% BLOCK category_row %]
    [%
        item.icon = 'folder'
        item.name = item.naam
        item.type = 'folder'
        item.url  = '/beheer/bibliotheek/' _ item.id
    %]
    [% item_count = get_element_count({c => c, bibliotheek_categorie_id => item.id}) %]
    [% item.count = BLOCK %]
        ([% item_count %])
    [% END %]

    [% item.actions = BLOCK %]

        <a href="[% c.uri_for('/beheer/bibliotheek/categorie/' _ item.id _ '/bewerken') %]" title="Categorie bewerken" class="popup">Bewerken</a>
        [% IF item_count == 0 %]
            <a href="[% c.uri_for('/beheer/bibliotheek/categorie/' _ item.id _ '/verwijderen') %]" title="Categorie verwijderen" class="popup">Verwijderen</a>
        [% END %]
    [% END %]

    [% PROCESS catalogue_row 
       ezra_dialog_layout = 'large'
    %]
[% END %]


[% BLOCK zaaktype_row %]
    [% #Dumper.dump(item.zaaktype_node_id.get_columns) %]
    [%
        item.version = item.zaaktype_node_id.version
        item.icon = 'case'
        item.name = item.zaaktype_node_id.titel
        item.type = 'zaaktype'
        item.url  = '/beheer/zaaktypen/' _ item.id _ '/bewerken'

        # These are not in scope at the moment, but let's list them anyway
        form.np       = c.uri_for('/aanvragen/' _ item.id _ '/persoon/' _ item.seo_friendly_title)
        form.nnp      = c.uri_for('/aanvragen/' _ item.id _ '/organisatie/' _ item.seo_friendly_title)
        form.anon     = c.uri_for('/aanvragen/' _ item.id _ '/onbekend/' _ item.seo_friendly_title)

        form.employee = c.uri_for('/form/employee/' _ item.id _ '/' _ item.seo_friendly_title)

    %]

    [% active = item.zaaktype_node_id.zaaktype_id.active %]
    [% item.is_active = BLOCK %]<span style="color: #ccc">[% IF active %][% ELSE %]offline[% END %]</span>[% END %]

    [% item.actions = BLOCK %]
        [% base_uri = c.uri_for('/beheer/zaaktypen/' _ item.id _ '/') %]
        <a href="[% base_uri %]bewerken">Bewerken</a>
        <a href="[% base_uri  %]clone">Dupliceren</a>
        <a href="[% base_uri %]verwijder" class="popup" title="Zaaktype verwijderen">Verwijderen</a>
        <a href="[% base_uri %]export">Exporteren</a>
        <a href="[% base_uri %]version" title="[% item.zaaktype_node_id.titel %]" class="popup">Versiebeheer</a>
           [% IF active %]
                <a href="[% base_uri %]offline" class="popup" title="Zaaktype offline zetten">Offline</a>
        [% ELSE %]
                <a href="[% base_uri %]online" class="popup" title="Zaaktype online zetten">Online</a>
        [% END %]

    [% END %]

    
    [% item.gebruik = BLOCK %]
        [%
            kenmerken = item.zaaktype_node_id.zaaktype_kenmerken.search(undef, {
                order_by => id,
                prefetch => 'bibliotheek_kenmerken_id'
            })

            sjablonen = item.zaaktype_node_id.zaaktype_sjablonen.search(undef, {
                prefetch => 'bibliotheek_sjablonen_id'
            })

            notificaties = item.zaaktype_node_id.zaaktype_notificaties.search(undef, {
                prefetch => 'bibliotheek_notificatie_id'
            })

            moeder_zaaktype_node = item.zaaktype_node_id.moeder_zaaktype_id.zaaktype_node_id;
        %]

        [%-
          is_content = 0;
          casetype_uuid = BLOCK;
            IF item.active;
            THEN; -%]
            <strong>Casetype UUID (api/v1)</strong><br/>
            [% item.uuid %]<br/>
        [% END; END; -%]

        [%-
          is_content = 0;
          uri_description = BLOCK;
            trigger_type = item.zaaktype_node_id.trigger;
            IF item.active;
            THEN; -%]
              [% IF trigger_type == 'intern' OR trigger_type == 'internextern';
              THEN -%]
            <strong>Registratie URI's</strong><br/>
              <a href="[% form.employee %]">Interne registratie</a><br/>
              [%- is_content = 1;
              END;
              IF trigger_type == 'extern' OR trigger_type == 'internextern';
              THEN;
              # We will want to have these here too, but for now, skip hem
              # '<a href="form.np">Persoon</a><br/>'
              # '<a href="form.nnp">Bedrijf</a><br/>'
              # '<a href="form.anon">Vooringevulde aanvrager</a><br/>'
              END;
            END;
        END; -%]

        [% moeder_zaaktype_description = BLOCK %]
            [% IF moeder_zaaktype_node %]
                [% IF is_content %]
                    <br/>
                [% END %]
                <strong>Moederzaaktype:</strong><br/>
                <a href="/beheer/zaaktypen/[% moeder_zaaktype_node.zaaktype_id.id %]/bewerken">[% moeder_zaaktype_node.titel %]</a>
                <br/>
                [% is_content = 1 %]
            [% END %]
        [% END %]
        
        [% kenmerken_description = BLOCK %]
            [%- IF kenmerken.first %]
            [%- IF is_content %]
                <br/>
            [%- END %]
                <strong>Kenmerken:</strong><br/>
                    [%- WHILE (kenmerk = kenmerken.next) %]
                      [%- NEXT IF kenmerk.bibliotheek_kenmerk_id.deleted || kenmerk.is_group %]
                      [% kenmerk.bibliotheek_kenmerken_id.naam %] [% IF kenmerk.referential %] (referentieel)[% END %]<br/>
                    [%- END %]
                [%- is_content = 1 %]
            [%- END %]
        [% END %]

        [% sjablonen_description = BLOCK %]
            [% IF sjablonen.first %]
                [% IF is_content %]
                    <br/>
                [% END %]
                <strong>Sjablonen:</strong><br/>
                    [% WHILE (sjabloon = sjablonen.next) %]
                        [% NEXT IF sjabloon.bibliotheek_sjablonen_id.deleted %]
                        [% sjabloon.bibliotheek_sjablonen_id.naam %]<br/>
                    [% END %]
                [% is_content = 1 %]
            [% END %]
        [% END %]

        [% notificaties_description = BLOCK %]
            [% IF notificaties.first %]
                [% IF is_content %]
                    <br/>
                [% END %]
                <strong>Notificaties:</strong><br/>
                    [% WHILE (notificatie = notificaties.next) %]
                        [% NEXT IF notificatie.bibliottheek_notificaties_id.deleted %]
                        [% notificatie.bibliotheek_notificaties_id.label %]<br/>
                    [% END %]
                [% is_content = 1 %]
            [% END %]
        [% END %]
        
        [% IF kenmerken.first || sjablonen.first || notificaties.first %]
            [% PROCESS description_icon
                description =
                    casetype_uuid
                  _ uri_description
                  _ moeder_zaaktype_description
                  _ kenmerken_description
                  _ sjablonen_description
                  _ notificaties_description
            %]
        [% END %]
    [% END %]

    [% PROCESS catalogue_row %]
[% END %]


[% BLOCK bibliotheek_sjablonen_row %]
    [%
        item.icon = 'sjablonen'
        item.name = item.naam
        item.type = 'sjabloon'
        item.url  = '/beheer/bibliotheek/sjablonen/' _
                        item.get_column('bibliotheek_categorie_id') _ '/' _ item.id
    %]
    [% casetypes = item.used_by_casetypes %]
    [% item.actions = BLOCK %]
        <a
            class="ezra_dialog"
            href="[% c.uri_for('/beheer/bibliotheek/sjablonen/' _ item.get_column('bibliotheek_categorie_id') _ '/' _ item.id _ '/bewerken') %]"
            rel="ezra_dialog_layout:xlarge"
            title="Sjabloon bewerken"
        >Bewerken</a>
        [% IF !casetypes %]
        <a class="popup"
            href="[% c.uri_for('/beheer/bibliotheek/sjablonen/' _ item.get_column('bibliotheek_categorie_id') _ '/' _ item.id _ '/verwijderen') %]"
            title="Sjabloon verwijderen"
        >Verwijderen</a>
        [% END %]
    [% END %]

    [% item.gebruik = BLOCK %]

        [% sjablonen_description = BLOCK %]
            <strong>Zaaktypen:</strong><br/>
            [%- FOR id IN casetypes.keys %]
                [% casetypes.$id.titel %]
                [%- IF !casetypes.$id.is_huidige_versie %]
                (Oude versie: [% casetypes.$id.version %])
                [%- ELSE %]
                (Huidige versie: [% casetypes.$id.version %])
                [% END %]
                </br>
            [% END %]
        [% END %]
        [% IF casetypes %]
            [% PROCESS description_icon
                description = sjablonen_description %]
        [% END %]
    [% END %]



    [% PROCESS catalogue_row 
        ezra_dialog_layout = 'xlarge'
    %]
[% END %]



[% BLOCK bibliotheek_notificaties_row %]
    [%
        item.icon = 'notificatie'
        item.name = item.label
        item.type = 'e-mail'
       # item.url  = '/beheer/bibliotheek/notificatie/' _
       #                 item.get_column('bibliotheek_categorie_id') _ '/' _ item.id
    %]
    [% item.actions = BLOCK %]
    <a
        data-zs-popup="'/html/admin/email-template.html'"
        data-ng-click="openPopup()"
        data-ng-init="category='[% bibliotheek_categorie_id %]';itemId=[% item.id %]"
    >Bewerken</a>
    <a class="popup"
        href="[% c.uri_for('/beheer/bibliotheek/notificaties/' _ item.id _ '/verwijderen') %]"
        title="E-mail verwijderen"
    >Verwijderen</a>
    [% END %]

    [% item.gebruik = BLOCK %]
        [% description = BLOCK %]
            [% zaaktypen = notificatie_zaaktypen.scalar.search({
                bibliotheek_notificaties_id => item.id 
            }); %]
            [% IF zaaktypen.count %]
                <strong>Zaaktypen:</strong><br/>
                [% WHILE(zaaktype = zaaktypen.next) %]
                    [% zaaktype.zaaktype_node_id.titel %]
                [% END %]
            [% END %]
        [% END %]        
        [% IF zaaktypen.count %]
             [% PROCESS description_icon %]
        [% END %]
    [% END %]


    [% PROCESS catalogue_row 
        ezra_dialog_layout = 'large'
    %]
[% END %]


[% BLOCK bibliotheek_kenmerken_row %]
    [%
        item.icon = 'kenmerken'
        item.name = item.naam
        item.type = 'kenmerk'
    %]
    [% casetypes = item.used_by_casetypes %]
    [% item.actions = BLOCK %]
        <a
            class="ezra_dialog"
            href="[% c.uri_for('/beheer/bibliotheek/kenmerken/' _ item.get_column('bibliotheek_categorie_id') _ '/' _ item.id _ '/bewerken') %]"
            rel="ezra_dialog_layout:xlarge"
            title="Kenmerk bewerken"
        >Bewerken</a>
        [% IF !casetypes %]
        <a class="popup"
            href="[% c.uri_for('/beheer/bibliotheek/kenmerken/' _ item.get_column('bibliotheek_categorie_id') _ '/' _ item.id _ '/verwijderen') %]"
            title="Kenmerk verwijderen"
        >Verwijderen</a>
        [% END %]
    [% END %]

    [% IF item.system %]
        [% item.is_systeem_kenmerk = 1 %]
    [% END %]

    [% item.gebruik = BLOCK %]
        [% kenmerken_description = BLOCK %]
            <strong>Magic string:</strong><br>
            [% item.magic_string | html_entity %]<br>
            <strong>Zaaktypen:</strong><br/>
            [%- FOR id IN casetypes.keys %]
                [% casetypes.$id.titel %]
                [%- IF !casetypes.$id.is_huidige_versie %]
                (Oude versie: [% casetypes.$id.version %])
                [%- ELSE %]
                (Huidige versie: [% casetypes.$id.version %])
                [% END %]
                </br>
            [% END %]
        [% END %]
        [% IF casetypes %]
            [% PROCESS description_icon
                description = kenmerken_description %]
        [% END %]
    [% END %]


    [% PROCESS catalogue_row 
        ezra_dialog_layout = 'xlarge'
    %]
[% END %]

[% BLOCK object_type_row %]
    [% item.icon = 'object' %]
    [% item.name = item.search_term %]
    [% item.type = 'objecttype' %]
    [% item.version = 'n/a' %]
    [% item.url = c.uri_for('/beheer/objecttypen/' _ item.get_column('object_uuid') _ '/bewerken/', { bibliotheek_categorie_id => item.get_column('bibliotheek_categorie_id') }) %]

    [% item.actions = BLOCK %]
        <a href="[% item.url %]">Openen</a>
        <button type="button" data-ng-controller="nl.mintlab.admin.objecttype.ObjectTypeRemoveController" data-zs-confirm="removeObject()" data-zs-confirm-verb="Verwijderen" data-zs-confirm-label="Weet u zeker dat u dit objecttype wil verwijderen?" data-ng-init="objectTypeId='[% item.get_column('object_uuid') %]'; objectTypeName='objecttype'">Verwijderen</button>
    [% END %]

    [% PROCESS catalogue_row %]
[% END %]

[% BLOCK object_product_row %]
    [% item.icon = 'kennisbank-product' %]
    [% item.name = item.search_term %]
    [% item.type = 'product' %]
    [% item.version = 'n/a' %]
    [% item.url = c.uri_for('/object/' _ item.get_column('object_uuid')) %]

    [% item.actions = BLOCK %]
        <a href="[% item.url %] ">Openen</a>
        <button type="button" data-ng-controller="nl.mintlab.admin.objecttype.ObjectTypeRemoveController" data-zs-confirm="removeObject()" data-zs-confirm-verb="Verwijderen" data-zs-confirm-label="Weet u zeker dat u dit product wil verwijderen?" data-ng-init="objectTypeId='[% item.get_column('object_uuid') %]'; objectTypeName='product'">Verwijderen</button>
    [% END %]

    [% PROCESS catalogue_row %]
[% END %]

[% BLOCK object_faq_row %]
    [% item.icon = 'kennisbank-vraag' %]
    [% item.name = item.search_term %]
    [% item.type = 'vraag' %]
    [% item.version = 'n/a' %]
    [% item.url = c.uri_for('/object/' _ item.get_column('object_uuid')) %]

    [% item.actions = BLOCK %]
        <a href="[% item.url %]">Openen</a>
        <button type="button" data-ng-controller="nl.mintlab.admin.objecttype.ObjectTypeRemoveController" data-zs-confirm="removeObject()" data-zs-confirm-verb="Verwijderen" data-zs-confirm-label="Weet u zeker dat u deze vraag wil verwijderen?" data-ng-init="objectTypeId='[% item.get_column('object_uuid') %]'; objectTypeName='vraag'">Verwijderen</button>
    [% END %]

    [% PROCESS catalogue_row %]
[% END %]

[% BLOCK crumbs %]
    [% IF bibliotheek_categorie_id %]
        (<a href="/beheer/bibliotheek/[% parent_categorie_id %]">up</a>)
    [% END %]

    [% crumb_count = 0 %]
    [% space = '&nbsp;' %]

    [% FOREACH crumb IN crumbs %]
        <br/>
        [% crumb_count = crumb_count + 1 %]
        [% space.repeat(crumb_count-1) %]
        
        [% IF crumb_count == crumbs.size %]
            <a class="icon-folder icon"></a>
            [% crumb.name | html_entity %]
        [% ELSE %]
            <a class="icon-folder icon" href="/beheer/bibliotheek/[% crumb.id %]"></a>
            <a class="" href="/beheer/bibliotheek/[% crumb.id %]">[% crumb.name %]</a>
        [% END %]
    [% END %]
[% END %]

[% PROCESS widgets/general/breadcrumbs.tt %]

<form name="zaaktypen_list">
    <input type="hidden" name="page" value="[% page %]"/>
    <div class="block">
        <div class="block-header header-with-actions clearfix">
            <div class="block-header-title">Catalogus</div>
            [% PROCESS catalogue_buttons %]
            
            [% PROCESS widgets/general/zaken_filter.tt %]
        </div>

        <div class="blockcontent">
        <div class="zaken_filter_wrapper">
        <div class="zaken_filter_inner">
            <div class="spinner-groot"><div></div></div>
            <table class="table-closed">
                [% IF results.pager.total_entries %]
                <thead>
                    <tr>
                        <th class="tdvar">[% c.loc('Titel') %]</th>
                        <th class="td100">[% c.loc('Type') %]</th>
                        <th class="td100">[% c.loc('Versie') %]</th>
                        <th class="td100">[% c.loc('Gebruik') %]</th>
                        [% IF ! categorie.system %]
                        <th class="td50">[% c.loc('Acties') %]</th>
                        [% END %]
                    </tr>
                </thead>
                <tbody>
    [% object_types = {
        'zaaktype'              => 'Zaaktype',
        'bibliotheek_kenmerken' => 'BibliotheekKenmerken',
        'bibliotheek_sjablonen' => 'BibliotheekSjablonen',
        'bibliotheek_notificaties' => 'BibliotheekNotificaties',
        'bibliotheek_categorie' => 'BibliotheekCategorie',
        'type'                  => 'ObjectBibliotheekEntry',
        'product'               => 'ObjectBibliotheekEntry',
        'faq'                   => 'ObjectBibliotheekEntry'
    } %]
        [% USE Dumper %]
                [% WHILE (result = results.next) %]
                    [% tablename = 'DB::' _ object_types.${result.object_type} %]
                    [% IF object_types.${result.object_type} %]
                        [% item = c.model(tablename).find(result.id) %]

                        [% IF item.object_type == 'bibliotheek_categorie' %]
                            [% PROCESS category_row %]
                        [% ELSIF item.object_type == 'bibliotheek_kenmerken' %]
                            [% PROCESS bibliotheek_kenmerken_row %]
                        [% ELSIF item.object_type == 'bibliotheek_sjablonen' %]
                            [% PROCESS bibliotheek_sjablonen_row %]
                        [% ELSIF item.object_type == 'bibliotheek_notificaties' %]
                            [% PROCESS bibliotheek_notificaties_row %]
                        [% ELSIF item.object_type == 'zaaktype' %]
                            [% PROCESS zaaktype_row %]
                        [% ELSIF item.object_type == 'type' %]
                            [% PROCESS object_type_row %]
                        [% ELSIF item.object_type == 'product' %]
                            [% PROCESS object_product_row %]
                        [% ELSIF item.object_type == 'faq' %]
                            [% PROCESS object_faq_row %]
                        [% ELSE %]
                            <tr><td>geen template</td></tr>
                        [% END %]
                    [% ELSE %]
                        <tr><td>[% c.loc('Error: Object type not defined for ') %][% Dumper.dump(result) %]</td></tr>
                    [% END %]
                [% END %]
                </tbody>
                [% ELSE %]
                    <tr><td>Geen resultaten</td></tr>
                [% END %]
            </table>
            [% PROCESS widgets/pager2.tt %]
            </div>
            </div>
        </div>
    </div>
</form>
